/*
Copyright (C) 1996-1997 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

//Dan East:
//This file has been modifed to remove all DirectX Sound calls.

#include "quakedef.h"
#include "winquake.h"

#define __SND_BUFFER__SIZE__ 1024
#include "SoundMgr.h"
static SndStreamRef snd_stream=NULL;
typedef struct {uint32 __r9;uint32 __r10;} reg_sys_t;
static reg_sys_t reg_sys;
int in_mix=0;


//#define iDirectSoundCreate(a,b,c)	pDirectSoundCreate(a,b,c)

//HRESULT (WINAPI *pDirectSoundCreate)(GUID FAR *lpGUID, LPDIRECTSOUND FAR *lplpDS, IUnknown FAR *pUnkOuter);

// 64K is > 1 second at 16-bit, 22050 Hz
/*#define	WAV_BUFFERS				64
#define	WAV_MASK				0x3F
#define	WAV_BUFFER_SIZE			0x0800	//0x0400	//Dan:
#define SECONDARY_BUFFER_SIZE	0x10000

typedef enum {SIS_SUCCESS, SIS_FAILURE, SIS_NOTAVAIL} sndinitstat;
*/
static qboolean	wavonly;
//static qboolean	dsound_init;
static qboolean	wav_init;
//static qboolean	snd_firsttime = true, snd_isdirect, snd_iswave;
//static qboolean	primary_format_set;

static int	sample16;
//static int	snd_sent, snd_completed;


/* 
 * Global variables. Must be visible to window-procedure function 
 *  so it can unlock and free the data block after it has been played. 
 */ 

/*HANDLE		hData;
//HPSTR		lpData, lpData2;
char 		*lpData, *lpData2;

HGLOBAL		hWaveHdr;
LPWAVEHDR	lpWaveHdr;

HWAVEOUT    hWaveOut; 

WAVEOUTCAPS	wavecaps;

DWORD	gSndBufSize;

MMTIME		mmstarttime;

//LPDIRECTSOUND pDS;
//LPDIRECTSOUNDBUFFER pDSBuf, pDSPBuf;

HINSTANCE hInstDS;

qboolean SNDDMA_InitDirect (void);
qboolean SNDDMA_InitWav (void);*/
qboolean SNDDMA_InitPalm (void);



static Err zq_sndCallBack (void *userData,SndStreamRef stream, void *bufferZ,UInt32 frameCountZ)
{
	__asm 
	{
		stmfd  r13!,{r9,r10}
		ldr	   r9,[r0]
		ldr	   r10,[r0,#4]
	}	
	if (!in_mix){
		in_mix=1;
		S_PaintChannels((Int8*)bufferZ,frameCountZ);
		in_mix=0;
	}
	__asm 
	{
		ldmfd  r13!,{r9,r10}
	}
	return errNone;
}


/*
==================
S_BlockSound
==================
*/
void S_BlockSound (void)
{
	snd_blocked++;
	if (snd_blocked == 1) {
		//waveOutReset (hWaveOut);
		stub_SndStreamStop(snd_stream);
		//stub_SndStreamDelete(snd_stream);
	}
}


/*
==================
S_UnblockSound
==================
*/
void S_UnblockSound (void)
{
	snd_blocked--;
	if( !snd_blocked) stub_SndStreamStart(snd_stream);
}


/*
==================
FreeSound
==================
*/
void FreeSound (void)
{
	int		i;
/*	if (hWaveOut)
	{
		waveOutReset (hWaveOut);

		if (lpWaveHdr)
		{
			for (i=0 ; i< WAV_BUFFERS ; i++)
				waveOutUnprepareHeader (hWaveOut, lpWaveHdr+i, sizeof(WAVEHDR));
		}

		waveOutClose (hWaveOut);

		if (hWaveHdr)
		{
			GlobalUnlock(hWaveHdr); 
			GlobalFree(hWaveHdr);
		}

		if (hData)
		{
			GlobalUnlock(hData);
			GlobalFree(hData);
		}

	}

//	pDS = NULL;
//	pDSBuf = NULL;
//	pDSPBuf = NULL;
	hWaveOut = 0;
	hData = 0;
	hWaveHdr = 0;
//	lpData = NULL;
	lpWaveHdr = NULL;
//	dsound_init = false;*/
	if (snd_stream){	
		stub_SndStreamStop(snd_stream);
		stub_SndStreamDelete(snd_stream);
		snd_stream=NULL;
	}
			
	wav_init = false;
}



/*
==================
SNDDM_InitWav

Crappy windows multimedia base
==================
*/
qboolean SNDDMA_InitPalm (void)
{
//	WAVEFORMATEX  format; 
	int				i;
//	HRESULT			hr;
	
/*	snd_sent = 0;
	snd_completed = 0;
*/
	shm = &sn;

	shm->channels = 2;
	shm->samplebits = 8;
	shm->speed = 11025;

/*	memset (&format, 0, sizeof(format));
	format.wFormatTag = WAVE_FORMAT_PCM;
	format.nChannels = shm->channels;
	format.wBitsPerSample = shm->samplebits;
	format.nSamplesPerSec = shm->speed;
	format.nBlockAlign = format.nChannels
		*format.wBitsPerSample / 8;
	format.cbSize = 0;
	format.nAvgBytesPerSec = format.nSamplesPerSec
		*format.nBlockAlign; 
*/	
	/* Open a waveform device for output using window callback. */ 
/*	while ((hr = waveOutOpen((LPHWAVEOUT)&hWaveOut, WAVE_MAPPER, 
					&format, 
					0, 0L, CALLBACK_NULL)) != MMSYSERR_NOERROR)
	{
		if (hr != MMSYSERR_ALLOCATED)
		{
			Con_SafePrintf ("waveOutOpen failed\n");
			return false;
		}

		if (MessageBox (NULL,
						_T("The sound hardware is in use by another app.\n\n")
					    _T("Select Retry to try to start sound again or Cancel to run Quake with no sound."),
						_T("Sound not available"),
						MB_RETRYCANCEL | MB_SETFOREGROUND | MB_ICONEXCLAMATION) != IDRETRY)
		{
			Con_SafePrintf ("waveOutOpen failure;\n"
							"  hardware already in use\n");
			return false;
		}
	} 
*/
  asm {
  	ldr  r0, = reg_sys
  	add	 r0,r0,r10
  	str	 r9,[r0]
  	str	 r10,[r0,#4]
  } 
	stub_SndStreamCreate(&snd_stream,sndOutput,shm->speed,(shm->samplebits==16?sndInt16Little:sndInt8),(shm->channels==2?sndStereo:sndMono),zq_sndCallBack,&reg_sys,__SND_BUFFER__SIZE__,1);
	stub_SndStreamStart(snd_stream);
	

	/* 
	 * Allocate and lock memory for the waveform data. The memory 
	 * for waveform data must be globally allocated with 
	 * GMEM_MOVEABLE and GMEM_SHARE flags. 

	*/ 
/*	gSndBufSize = WAV_BUFFERS*WAV_BUFFER_SIZE;
	hData = GlobalAlloc(GMEM_MOVEABLE | GMEM_SHARE, gSndBufSize); 
	if (!hData) 
	{ 
		Con_SafePrintf ("Sound: Out of memory.\n");
		FreeSound ();
		return false; 
	}

	lpData = GlobalLock(hData);
	if (!lpData)
	{ 
		Con_SafePrintf ("Sound: Failed to lock.\n");
		FreeSound ();
		return false; 
	} 
	memset (lpData, 0, gSndBufSize);
*/
	/* 
	 * Allocate and lock memory for the header. This memory must 
	 * also be globally allocated with GMEM_MOVEABLE and 
	 * GMEM_SHARE flags. 
	 */ 
/*	hWaveHdr = GlobalAlloc(GMEM_MOVEABLE | GMEM_SHARE, 
		(DWORD) sizeof(WAVEHDR) * WAV_BUFFERS); 

	if (hWaveHdr == NULL)
	{ 
		Con_SafePrintf ("Sound: Failed to Alloc header.\n");
		FreeSound ();
		return false; 
	} 

	lpWaveHdr = (LPWAVEHDR) GlobalLock(hWaveHdr); 

	if (lpWaveHdr == NULL)
	{ 
		Con_SafePrintf ("Sound: Failed to lock header.\n");
		FreeSound ();
		return false; 
	}

	memset (lpWaveHdr, 0, sizeof(WAVEHDR) * WAV_BUFFERS);
*/
	/* After allocation, set up and prepare headers. */ 
/*	for (i=0 ; i<WAV_BUFFERS ; i++)
	{
		lpWaveHdr[i].dwBufferLength = WAV_BUFFER_SIZE; 
		lpWaveHdr[i].lpData = lpData + i*WAV_BUFFER_SIZE;

		if (waveOutPrepareHeader(hWaveOut, lpWaveHdr+i, sizeof(WAVEHDR)) !=
				MMSYSERR_NOERROR)
		{
			Con_SafePrintf ("Sound: failed to prepare wave headers\n");
			FreeSound ();
			return false;
		}
	}
*/
	shm->soundalive = true;
	shm->splitbuffer = false;
	shm->samples = __SND_BUFFER__SIZE__;///(shm->samplebits/8);
	shm->samplepos = 0;
	shm->submission_chunk = 1;
	shm->buffer = NULL;//(unsigned char *) lpData;
	sample16 = (shm->samplebits/8) - 1;

	wav_init = true;

	return true;
}

/*
==================
SNDDMA_Init

Try to find a sound device to mix for.
Returns false if nothing is found.
==================
*/

int SNDDMA_Init(void)
{
//	sndinitstat	stat;

//	if (COM_CheckParm ("-wavonly"))
//		wavonly = true;

	/*dsound_init =*/ wav_init = 0;

//	stat = SIS_FAILURE;	// assume DirectSound won't initialize

	/* Init DirectSound */
/*
	if (!wavonly)
	{
		if (snd_firsttime || snd_isdirect)
		{
			stat = SNDDMA_InitDirect ();;

			if (stat == SIS_SUCCESS)
			{
				snd_isdirect = true;

				if (snd_firsttime)
					Con_SafePrintf ("DirectSound initialized\n");
			}
			else
			{
				snd_isdirect = false;
				Con_SafePrintf ("DirectSound failed to init\n");
			}
		}
	}
*/
// if DirectSound didn't succeed in initializing, try to initialize
// waveOut sound, unless DirectSound failed because the hardware is
// already allocated (in which case the user has already chosen not
// to have sound)
/*	if (!dsound_init && (stat != SIS_NOTAVAIL))
	{
		if (snd_firsttime || snd_iswave)
		{

			snd_iswave = SNDDMA_InitWav ();

			if (snd_iswave)
			{
				if (snd_firsttime)
					Con_SafePrintf ("Wave sound initialized\n");
			}
			else
			{
				Con_SafePrintf ("Wave sound failed to init\n");
			}
		}
//	}

	snd_firsttime = false;
*/
SNDDMA_InitPalm ();
//	if (/*!dsound_init &&*/ !wav_init)
/*	{
		if (snd_firsttime)
			Con_SafePrintf ("No sound device initialized\n");

		return 0;
	}
*/
	return 1;
}

/*
==============
SNDDMA_Shutdown

Reset the sound device for exiting
===============
*/
void SNDDMA_Shutdown(void)
{
	FreeSound ();
}

